<?php
namespace Teknisa\CNC\Factories;

use Doctrine\ORM\EntityManager;

class Cnc00500VendaPorAdquirente {

    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }
    
    public function getVendasPorAdquirenteRecebidas($params){
        $sql = "SELECT SUM(DECODE(:TIPOVENDA, 1, RET.VRLIQPGTO, 2, RET.VRBRUTVENDA)) VRVENDA, ADQ.NMADQUIRENTE
                FROM RETFINANCADQ RET,
                (SELECT NMADQUIRENTE, NRADQUIRENTE
                  FROM ADQUIRENTE 
                  WHERE ((INSTR (:NRADQUIRENTE, '|'||NRADQUIRENTE||'|')  > 0) OR ('T' = :NRADQUIRENTE))
                    AND NRORG = :NRORG) ADQ
                  WHERE ((INSTR (:NRESTABELEC, '|'||RET.NRESTABELEC||'|') > 0) OR ('T' = :NRESTABELEC))
                  AND RET.NRORG = :NRORG
                  AND ((INSTR (:NRADQUIRENTE, '|'||RET.NRADQUIRENTE||'|') > 0) OR ('T' = :NRADQUIRENTE))
                  AND RET.NRADQUIRENTE = ADQ.NRADQUIRENTE
                  AND RET.DTCREDITO BETWEEN :DTVENDAINI AND :DTVENDAEND
                GROUP BY ADQ.NMADQUIRENTE";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function getVendasPorAdqRecDetalhes($params){
        $sql = "SELECT SUM(DECODE(:TIPOVENDA, 1, RET.VRLIQPGTO, 2, RET.VRBRUTVENDA)) VRVENDA, ADQ.NMADQUIRENTE, ADQ.NRADQUIRENTE, RET.NRESTABELEC
                FROM RETFINANCADQ RET,
                (SELECT NMADQUIRENTE, NRADQUIRENTE
                  FROM ADQUIRENTE 
                  WHERE ((INSTR (:NRADQUIRENTE, '|'||NRADQUIRENTE||'|')  > 0) OR ('T' = :NRADQUIRENTE))
                    AND NRORG = :NRORG) ADQ
                  WHERE ((INSTR (:NRESTABELEC, '|'||RET.NRESTABELEC||'|') > 0) OR ('T' = :NRESTABELEC))
                  AND RET.NRORG = :NRORG
                  AND ((INSTR (:NRADQUIRENTE, '|'||RET.NRADQUIRENTE||'|') > 0) OR ('T' = :NRADQUIRENTE))
                  AND RET.NRADQUIRENTE = ADQ.NRADQUIRENTE
                  AND RET.DTCREDITO BETWEEN :DTVENDAINI AND :DTVENDAEND
                GROUP BY ADQ.NMADQUIRENTE, ADQ.NRADQUIRENTE, RET.NRESTABELEC
        ";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function getVendasPorAdquirentePrevistas($params){
        $sql = "SELECT SUM(DECODE(:TIPOVENDA, 1, RET.VRLIQVENDA, 2, RET.VRBRUTVENDA)) VRVENDA, ADQ.NMADQUIRENTE
                FROM RETVENDAADQ RET, ADQUIRENTE ADQ
                WHERE RET.NRORG = :NRORG 
                  AND ((INSTR (:NRADQUIRENTE, '|'||RET.NRADQUIRENTE||'|') > 0) OR ('T' = :NRADQUIRENTE))
                  AND ((INSTR (:NRESTABELEC, '|'||RET.NRESTABELEC||'|') > 0) OR ('T' = :NRESTABELEC))
                  AND ((INSTR (:NRADQUIRENTE, '|'||RET.NRADQUIRENTE||'|')  > 0) OR ('T' = :NRADQUIRENTE))
                  AND RET.NRADQUIRENTE = ADQ.NRADQUIRENTE
                  AND RET.DTVENDA BETWEEN :DTVENDAINI AND :DTVENDAEND
                GROUP BY ADQ.NMADQUIRENTE";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function getVendasPorAdqPrevDetalhes($params){
        $sql = "SELECT SUM(DECODE(:TIPOVENDA, 1, RET.VRLIQVENDA, 2, RET.VRBRUTVENDA)) VRVENDA, ADQ.NMADQUIRENTE, 
                ADQ.NMADQUIRENTE, ADQ.NRADQUIRENTE, RET.NRESTABELEC, RET.DTCREDITO DTVENDA
                FROM RETVENDAADQ RET, ADQUIRENTE ADQ
                WHERE RET.NRORG = :NRORG 
                  AND RET.NRORG = ADQ.NRORG
                  AND ((INSTR (:NRADQUIRENTE, '|'||RET.NRADQUIRENTE||'|')  > 0) OR ('T' = :NRADQUIRENTE))
                  AND ((INSTR (:NRESTABELEC, '|'||RET.NRESTABELEC||'|') > 0) OR ('T' = :NRESTABELEC))
                  AND ((INSTR (:NRADQUIRENTE, '|'||RET.NRADQUIRENTE||'|') > 0) OR ('T' = :NRADQUIRENTE))
                  AND RET.NRADQUIRENTE = ADQ.NRADQUIRENTE
                  AND RET.DTVENDA BETWEEN :DTVENDAINI AND :DTVENDAEND
                GROUP BY ADQ.NMADQUIRENTE, ADQ.NMADQUIRENTE, ADQ.NRADQUIRENTE, RET.NRESTABELEC, RET.DTCREDITO";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
	
	public function selectDetailsFinanc ($params) {
	    $sql = "SELECT A.NRADQUIRENTE AS PRIMARY, NULL AS PARENT, A.NMADQUIRENTE, NULL AS CDNSU, 
                  NULL AS DTCREDITO, SUM(RF.VRBRUTVENDA) AS VRBRUTVENDA, SUM(RF.VRLIQPGTO) AS VRLIQVENDA, NULL AS NMESTABELEC
                FROM ADQUIRENTE A, RETFINANCADQ RF
                 LEFT JOIN CONSMOVCAIXA CON
                  ON CON.NRCONCLANC = RF.NRCONCLANC
                WHERE A.NRADQUIRENTE = RF.NRADQUIRENTE
                  AND A.NRORG = :NRORG
                  AND RF.DTCREDITO BETWEEN :DTVENDA_MIN AND :DTVENDA_MAX
                  AND (INSTR (:NRESTABELEC, '|'||TO_CHAR(RF.NRESTABELEC)||'|') > 0) 
                  AND (INSTR (:NRADQUIRENTE, '|'||TO_CHAR(RF.NRADQUIRENTE)||'|') > 0)
                  GROUP BY  A.NRADQUIRENTE, A.NMADQUIRENTE                
              UNION
                SELECT NULL AS PRIMARY, RF.NRADQUIRENTE AS PARENT, NULL AS NMADQUIRENTE, RF.CDNSU,
                  TO_DATE(TO_CHAR(RF.DTCREDITO, 'DD/MM/YYYY'), 'DD/MM/YYYY') DTCREDITO, 
                  RF.VRBRUTVENDA, RF.VRLIQPGTO VRLIQVENDA, E.NMESTABELEC
                FROM RETFINANCADQ RF
                LEFT JOIN CONSMOVCAIXA CON
                 ON CON.NRCONCLANC = RF.NRCONCLANC, ESTABELECIMENTO E
                WHERE RF.NRORG = :NRORG
                  AND RF.NRESTABELEC = E.NRESTABELEC
                  AND RF.DTCREDITO BETWEEN :DTVENDA_MIN AND :DTVENDA_MAX
                  AND (INSTR (:NRESTABELEC, '|'||TO_CHAR(RF.NRESTABELEC)||'|') > 0) 
                  AND (INSTR (:NRADQUIRENTE, '|'||TO_CHAR(RF.NRADQUIRENTE)||'|') > 0)
                ORDER BY DTCREDITO, CDNSU";
	    
	    $std = $this->connection->prepare($sql);
	    $std->execute($params);
	    return $std->fetchAll();
	}
	
	public function selectDetailsVendaAdq ($params) {
	    $sql = "SELECT A.NRADQUIRENTE AS PRIMARY, NULL AS PARENT, A.NMADQUIRENTE, NULL AS CDNSU, 
                  NULL AS DTCREDITO, SUM(RV.VRBRUTVENDA) AS VRBRUTVENDA, SUM(RV.VRLIQVENDA) AS VRLIQVENDA, NULL AS NMESTABELEC
                FROM ADQUIRENTE A, RETVENDAADQ RV
                LEFT JOIN CONSMOVCAIXA CON
                ON CON.NRCONCLANC = RV.NRCONCLANC
                WHERE A.NRADQUIRENTE = RV.NRADQUIRENTE
                  AND A.NRORG = :NRORG
                  AND RV.DTVENDA BETWEEN :DTVENDA_MIN AND :DTVENDA_MAX
                  AND (INSTR (:NRESTABELEC, '|'||TO_CHAR(RV.NRESTABELEC)||'|') > 0) 
                  AND (INSTR (:NRADQUIRENTE, '|'||TO_CHAR(RV.NRADQUIRENTE)||'|') > 0)
                GROUP BY A.NRADQUIRENTE, A.NMADQUIRENTE
                UNION
              SELECT NULL AS PRIMARY, RV.NRADQUIRENTE AS PARENT, NULL AS NMADQUIRENTE, RV.CDNSU,
                  TO_CHAR(RV.DTCREDITO, 'DD/MM/YYYY') DTCREDITO, RV.VRBRUTVENDA, RV.VRLIQVENDA VRLIQVENDA,
                  E.NMESTABELEC
                FROM RETVENDAADQ RV LEFT JOIN CONSMOVCAIXA CON
                  ON RV.NRCONCLANC = CON.NRCONCLANC, ESTABELECIMENTO E
                WHERE RV.NRORG = :NRORG
                  AND RV.NRESTABELEC = E.NRESTABELEC
                  AND RV.DTVENDA BETWEEN :DTVENDA_MIN AND :DTVENDA_MAX
                  AND (INSTR (:NRESTABELEC, '|'||TO_CHAR(RV.NRESTABELEC)||'|') > 0)
                  AND (INSTR (:NRADQUIRENTE, '|'||TO_CHAR(RV.NRADQUIRENTE)||'|') > 0)
                ORDER BY DTCREDITO, CDNSU";
	    
	    $std = $this->connection->prepare($sql);
	    $std->execute($params);
	    return $std->fetchAll();
	}
}