<?php

namespace Teknisa\CNC\Services;

use Teknisa\CNC\Factories\Cnc02300StatusVendasFactory;

class Cnc02300StatusVendasService {
    protected $factory;
    
    public function __construct (Cnc02300StatusVendasFactory $factory) {
        $this->factory = $factory;
    }
    
    public function getStatusVendas ($params) {
        return $this->factory->getStatusVendas(array(
            ":NRORG"         => $params["NRORG"],
            ":NRESTABELEC"   => $params["NRESTABELEC"],
            ":TNRESTABELEC"  => $params["TNRESTABELEC"],
            ":NRPRODUTOADQ"  => $params["NRPRODUTOADQ"],
            ":TNRPRODUTOADQ" => $params["TNRPRODUTOADQ"],
            ":DTVENDA_INI"   => $params["DTVENDA"]["start"],
            ":DTVENDA_FIM"   => $params["DTVENDA"]["end"]
        ));
    }
    
    public function getStatusVendasDetails ($params) {
        return $this->factory->getStatusVendasDetails(array(
            ":NRORG"         => $params["NRORG"],
            ":NRESTABELEC"   => $params["NRESTABELEC"],
            ":TNRESTABELEC"  => $params["TNRESTABELEC"],
            ":NRPRODUTOADQ"  => $params["NRPRODUTOADQ"],
            ":TNRPRODUTOADQ" => $params["TNRPRODUTOADQ"],
            ":DTVENDA_INI"   => $params["DTVENDA"]["start"],
            ":DTVENDA_FIM"   => $params["DTVENDA"]["end"]
        ));
    }
    
}