# ? Backend

#### 1 - Declaração

Para declarar uma rota basta adicionar um objeto no arquivo `src/routes.json`

```
{
    "name"       : "/myRoute",
    "controller" : "MyController",
    "method"     : "myRoute",
    "type"       : "POST"
}
```

#### 2 - Controller

```
namespace App\Controller;

use \Exception as Exception;
use Psr\Http\Message\ResponseInterface as Response;
use Psr\Http\Message\ServerRequestInterface as Request;

class MyController {
    protected $myService;

	public function __construct(\App\Service\MyTest $myService) {
        $this->myService = $myService;
	}
	
    public function myRoute(Request $request, Response $response) {
        try {
            $consumerParams['CDCLIENTE']    = 'O00001';
            $consumerParams['CDCONSUMIDOR'] = 'SDE000000000000000335';

            return $response->withJson(array(
                'success' => true,
                'message' => '',
                'result'  => $this->myService->getConsumer($consumerParams)
            ));
        } catch (Exception $e) {
            return $response->withJson(array(
                'success' => false,
                'message' => $e->getMessage(),
                'result'  => []
            ));
        }
    }
}
```